package main

import (
	"fmt"
	"trailblazer2/app/codecs"
)

func main() {
	aa := []int32{1}
	aa = append(aa, 12)
	aa = append(aa, 23)

	fmt.Println(aa)

	a := "asdfasdf"
	b := "3c6d08d667d0ee0ccad77c55b19d3e4ab2552f7163ec40a9389095a18f86c398"

	//fmt.Println()
	fmt.Println(codecs.Encode(a, b))
}

func s(origin string, b bool) (result []int32) {
	data := []int32(origin)
	dataLen := len(origin)

	resultLen := (dataLen / 4) + 1
	if b {
		result = make([]int32, resultLen+1)
		result[resultLen] = int32(resultLen)
	} else {
		result = make([]int32, resultLen)
	}

	for i := 0; i < dataLen; i += 4 {
		result[i>>2] =
			getCharAt(data, i, dataLen) | getCharAt(data, i+1, dataLen)<<8 | getCharAt(data, i+2, dataLen)<<16 |
				getCharAt(data, i+3, dataLen)<<24
	}

	return result
}

func getCharAt(data []int32, index int, length int) int32 {
	if index >= length {
		return 0
	} else {
		return data[index]
	}
}

func l(a []int32, b bool) (result []int32) {
	d := len(a)

	c := d - 1<<2

	if b {
		m := int(a[d-1])
		if m < c-3 || m > c {
			return nil
		}
		c = m
	}

	for i := 0; i < d; i++ {
		result = append(result, a[i]&0xff, a[i]>>8&0xff, a[i]>>16&0xff, a[i]>>24&0xff)
	}

	if b {
		return append(result, int32(c))
	} else {
		return result
	}
}
